mod json_fs_store;
pub use json_fs_store::*;

mod direct_fs_store;
pub use direct_fs_store::*;

use crate::domain::tls::{CertificateChain, PrivateKey};
use crate::error::unexpected;

#[mockall::automock]
pub trait Store {
    fn set_certificate(
        &self,
        domain: &str,
        key: PrivateKey,
        cert: CertificateChain,
    ) -> Result<(), unexpected::Error>;

    /// Returned chain is guaranteed to have len > 0
    fn get_certificate(
        &self,
        domain: &str,
    ) -> unexpected::Result<Option<(PrivateKey, CertificateChain)>>;
}
