use serde::{Deserialize, Serialize};
use std::net;

fn default_gemini_addr() -> Option<net::SocketAddr> {
    Some("[::]:3965".parse().unwrap())
}

#[derive(Deserialize, Serialize, Clone)]
pub struct Config {
    #[serde(default = "default_gemini_addr")]
    pub gemini_addr: Option<net::SocketAddr>,
}

impl Default for Config {
    fn default() -> Self {
        Self {
            gemini_addr: default_gemini_addr(),
        }
    }
}
